#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3d10.lib")
#pragma comment(lib, "d3dx10.lib")

#include <windows.h>
#include <tchar.h>
#include <d3d10.h>
#include <d3dx10.h>
#include "oxcp.h"
#include "oxnumericcounter.h"
#include "oxnumber8x8.h"


using namespace OX;

int cameraCurRot_g = 0;
int curTexIdx_g = 0;
bool bSaveToFile_g = false;

// EBhEvV[W
LRESULT CALLBACK WndProc( HWND hWnd, UINT mes, WPARAM wParam, LPARAM lParam ) {

	static int cameraRotStartVal = 0;

	switch ( mes ) {
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;
	case WM_LBUTTONDOWN:
		cameraRotStartVal = LOWORD( lParam );
		break;
	case WM_MOUSEMOVE:
		if ( wParam & MK_LBUTTON ) {
			int cameraRotDif = LOWORD( lParam ) - cameraRotStartVal;
			cameraRotStartVal = LOWORD( lParam );
			cameraCurRot_g += cameraRotDif;
		}
		break;
	case WM_CHAR:
		if ( wParam == 's' ) {
			bSaveToFile_g = true;
		}
		else if ( wParam == 'd' ) {
			curTexIdx_g = ( curTexIdx_g + 1 ) % 4;
		}
		break;
	}
	return DefWindowProc( hWnd, mes, wParam, lParam );
}

// C
int APIENTRY _tWinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow )
{
	// EBhE쐬
	MSG msg; HWND hWnd;
	TCHAR gName[] = _T( "WIgVF[_TvvO" );
	WNDCLASSEX wcex = { sizeof( WNDCLASSEX ), CS_HREDRAW | CS_VREDRAW, WndProc, 0, 0, hInstance, NULL, NULL,
		(HBRUSH)( COLOR_WINDOW + 1 ), NULL, (TCHAR*)gName, NULL };
	if ( !RegisterClassEx( &wcex ) )
		return 0;

	int w = 1000, h = 750;
	RECT clientRect = { 0, 0, w, h };
	::AdjustWindowRect( &clientRect, WS_OVERLAPPEDWINDOW, FALSE );

	if ( !( hWnd = CreateWindow( gName, gName, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0,
		clientRect.right - clientRect.left, clientRect.bottom - clientRect.top,
		NULL, NULL, hInstance, NULL ) ) )
		return 0;

	ShowWindow( hWnd, nCmdShow );


	// Direct3D10̏ //
	cp< ID3D10Device > cpDevice_;
	cp< IDXGISwapChain > cpSwapChain_;
	cp< ID3D10RenderTargetView > cpRenderTargetView_;

	// Xbv`FCƃfoCX̏
	{
		DXGI_SWAP_CHAIN_DESC desc;
		memset( &desc, 0, sizeof( desc ) );
		desc.BufferCount = 1;
		desc.BufferDesc.Width = w;
		desc.BufferDesc.Height = h;
		desc.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
		desc.BufferDesc.Scaling = DXGI_MODE_SCALING_UNSPECIFIED;
		desc.BufferDesc.RefreshRate.Numerator = 60;
		desc.BufferDesc.RefreshRate.Denominator = 1;
		desc.BufferDesc.ScanlineOrdering = DXGI_MODE_SCANLINE_ORDER_UNSPECIFIED;
		desc.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
		desc.Flags = DXGI_SWAP_CHAIN_FLAG_ALLOW_MODE_SWITCH;
		desc.OutputWindow = hWnd;
		desc.SampleDesc.Count = 1;
		desc.SampleDesc.Quality = 0;
		desc.SwapEffect = DXGI_SWAP_EFFECT_DISCARD;
		desc.Windowed = TRUE;

		if ( FAILED( D3D10CreateDeviceAndSwapChain(
			0,
			D3D10_DRIVER_TYPE_HARDWARE,
			0,
			0,
			D3D10_SDK_VERSION,
			&desc,
			cpSwapChain_.toCreator(),
			cpDevice_.toCreator()
		) ) ) {
			return false;
		}
	}

	// obNobt@m
	ID3D10Texture2D *backBuffer;
	if ( FAILED( cpSwapChain_->GetBuffer( 0, __uuidof( ID3D10Texture2D ), (void**)&backBuffer ) ) ) {
		return false;
	}

	cp< ID3D10RenderTargetView > backBufferRenderTargetView_;
	if ( FAILED( cpDevice_->CreateRenderTargetView( backBuffer, 0, backBufferRenderTargetView_.toCreator() ) ) ) {
		return false;
	}
	cpDevice_->OMSetRenderTargets( 1, backBufferRenderTargetView_.getPtrPtr(), 0 );	// o̓}[Wɐݒ

	// [xXeVobt@쐬
	cp< ID3D10Texture2D > depthStencil;
	D3D10_TEXTURE2D_DESC dstDesc;
	dstDesc.Width = w;
	dstDesc.Height = h;
	dstDesc.MipLevels = 1;
	dstDesc.ArraySize = 1;
	dstDesc.Format = DXGI_FORMAT_D32_FLOAT;
	dstDesc.SampleDesc.Count = 1;
	dstDesc.SampleDesc.Quality = 0;
	dstDesc.Usage = D3D10_USAGE_DEFAULT;
	dstDesc.BindFlags = D3D10_BIND_DEPTH_STENCIL;
	dstDesc.CPUAccessFlags = 0;
	dstDesc.MiscFlags = 0;
	cpDevice_->CreateTexture2D( &dstDesc, 0, depthStencil.toCreator() );

	cp< ID3D10DepthStencilView > dsView;
	D3D10_DEPTH_STENCIL_VIEW_DESC dsvDesc;
	dsvDesc.Format = dstDesc.Format;
	dsvDesc.ViewDimension = D3D10_DSV_DIMENSION_TEXTURE2D;
	dsvDesc.Texture2D.MipSlice = 0;
	cpDevice_->CreateDepthStencilView( depthStencil.getPtr(), &dsvDesc, dsView.toCreator() );

	// r[|[gݒ
	D3D10_VIEWPORT vp;
	vp.TopLeftX = 0;
	vp.TopLeftY = 0;
	vp.Width = w;
	vp.Height = h;
	vp.MinDepth = 0.0f;
	vp.MaxDepth = 1.0f;

	// _obt@
	// |쐬
	struct V {
		float x, y, z;
		float u, v;
	} vertices[ 4 ] = {
		{ -1.0f, -1.0f, 0.0f, 0.0f, 1.0f },
	{ -1.0f, 1.0f, 0.0f, 0.0f, 0.0f },
	{ 1.0f, -1.0f, 0.0f, 1.0f, 1.0f },
	{ 1.0f, 1.0f, 0.0f, 1.0f, 0.0f },
	};
	uint32_t verticesSize = sizeof( vertices );

	uint32_t indices[ 4 ] = {
		0, 1, 2, 3
	};
	uint32_t indicesSize = sizeof( indices );

	D3D10_BUFFER_DESC vtxBufDesc;
	vtxBufDesc.Usage = D3D10_USAGE_DEFAULT;
	vtxBufDesc.ByteWidth = verticesSize;
	vtxBufDesc.BindFlags = D3D10_BIND_VERTEX_BUFFER;
	vtxBufDesc.CPUAccessFlags = 0;
	vtxBufDesc.MiscFlags = 0;

	D3D10_SUBRESOURCE_DATA vtxData;
	memset( &vtxData, 0, sizeof( vtxData ) );
	vtxData.pSysMem = &vertices[ 0 ];

	cp< ID3D10Buffer > vtxBuffer;
	cpDevice_->CreateBuffer( &vtxBufDesc, &vtxData, vtxBuffer.toCreator() );

	// ̓CAEgvf
	D3D10_INPUT_ELEMENT_DESC layout[] = {
		{ "POSITION", 0, DXGI_FORMAT_R32G32B32_FLOAT, 0, 0, D3D10_INPUT_PER_VERTEX_DATA, 0 },
		{ "TEXCOORD", 0, DXGI_FORMAT_R32G32_FLOAT, 0, 12, D3D10_INPUT_PER_VERTEX_DATA, 0 }
	};

	// CfbNXobt@
	D3D10_BUFFER_DESC idxBufDesc;
	memset( &idxBufDesc, 0, sizeof( idxBufDesc ) );
	idxBufDesc.Usage = D3D10_USAGE_DEFAULT;
	idxBufDesc.ByteWidth = indicesSize;
	idxBufDesc.BindFlags = D3D10_BIND_INDEX_BUFFER;

	D3D10_SUBRESOURCE_DATA idxData;
	memset( &idxData, 0, sizeof( idxData ) );
	idxData.pSysMem = &indices[ 0 ];

	cp< ID3D10Buffer > idxBuffer;
	cpDevice_->CreateBuffer( &idxBufDesc, &idxData, idxBuffer.toCreator() );

	// GtFNg
	cp< ID3D10Effect > effect;
	ID3D10Blob *err = 0;
	auto res = D3DX10CreateEffectFromFile( "texture_draw.fx", 0, 0, "fx_4_0", D3D10_SHADER_ENABLE_STRICTNESS, 0, cpDevice_.getPtr(), 0, 0, effect.toCreator(), &err, 0 );;
	if ( FAILED( res ) ) {
		const char* errStr = (const char*)err->GetBufferPointer();
		OutputDebugStringA( errStr );
		return -1;
	}

	// ̓CAEg
	cp< ID3D10InputLayout > vtxLayout;
	ID3D10EffectTechnique *tech = effect->GetTechniqueByName( "tech" );
	ID3D10EffectPass *pass = tech->GetPassByIndex( 0 );
	D3D10_PASS_DESC passDesc;
	pass->GetDesc( &passDesc );
	cpDevice_->CreateInputLayout( layout, 2, passDesc.pIAInputSignature, passDesc.IAInputSignatureSize, vtxLayout.toCreator() );

	// 摜t@CeNX`쐬
	D3DX10_IMAGE_INFO imageInfo;
	D3DX10_IMAGE_LOAD_INFO loadInfo;
	ID3D10Resource *fileResource = 0;
	cp< ID3D10Texture2D > cpFileResTex;

	loadInfo.Width = 256;
	loadInfo.Height = 256;
	loadInfo.CpuAccessFlags = 0;
	loadInfo.BindFlags = D3D10_BIND_SHADER_RESOURCE;
	loadInfo.Depth = 0;
	loadInfo.Filter = D3DX10_FILTER_POINT;
	loadInfo.MipFilter = D3DX10_FILTER_POINT;
	loadInfo.Usage = D3D10_USAGE_DEFAULT;
	loadInfo.FirstMipLevel = 0;
	loadInfo.MipLevels = 1;
	loadInfo.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	loadInfo.MiscFlags = 0;
	loadInfo.pSrcInfo = 0;

	D3DX10CreateTextureFromFileA( cpDevice_.getPtr(), "sample01.png", &loadInfo, 0, &fileResource, 0 );

	D3D10_RESOURCE_DIMENSION resDim;
	fileResource->GetType( &resDim );
	if ( resDim != D3D10_RESOURCE_DIMENSION_TEXTURE2D ) {
		return -1;
	}
	cpFileResTex = cp< ID3D10Texture2D >( (ID3D10Texture2D*)fileResource );	// 2DeNX`ƂĈ

	// GPUANZX̂݉\ȓIeNX`쐬
	D3D10_TEXTURE2D_DESC gpu2DTexDesc;
	D3D10_SUBRESOURCE_DATA gpu2DTexSubRes;
	cp< ID3D10Texture2D > cpGpu2DTex;

	gpu2DTexDesc.Width = 4;
	gpu2DTexDesc.Height = 4;
	gpu2DTexDesc.CPUAccessFlags = 0;
	gpu2DTexDesc.BindFlags = D3D10_BIND_SHADER_RESOURCE;
	gpu2DTexDesc.Usage = D3D10_USAGE_DEFAULT;
	gpu2DTexDesc.MipLevels = 1;
	gpu2DTexDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	gpu2DTexDesc.MiscFlags = 0;
	gpu2DTexDesc.ArraySize = 1;
	gpu2DTexDesc.SampleDesc.Count = 1;
	gpu2DTexDesc.SampleDesc.Quality = 0;

	uint32_t rt2DTexData[4 * 4] = {
		0xffffffff, 0xff0000ff, 0xff0000ff, 0xffffffff,
		0xffffffff, 0xff00ff00, 0xff00ff00, 0xffffffff,
		0xffffffff, 0xffff0000, 0xffff0000, 0xffffffff,
		0xffffffff, 0xffff00ff, 0xffff00ff, 0xffffffff,
	};

	gpu2DTexSubRes.pSysMem = rt2DTexData;
	gpu2DTexSubRes.SysMemPitch = sizeof( uint32_t ) * 4;
	gpu2DTexSubRes.SysMemSlicePitch = gpu2DTexSubRes.SysMemPitch * 4;

	cpDevice_->CreateTexture2D( &gpu2DTexDesc, &gpu2DTexSubRes, cpGpu2DTex.toCreator() );	// 쐬K{

	// CPUANZX\ȓIeNX`쐬
	D3D10_TEXTURE2D_DESC gpuCpu2DTexDesc;
	cp< ID3D10Texture2D > cpGpuCpu2DTex;

	gpuCpu2DTexDesc.Width = 8;
	gpuCpu2DTexDesc.Height = 8;
	gpuCpu2DTexDesc.CPUAccessFlags = D3D10_CPU_ACCESS_WRITE;
	gpuCpu2DTexDesc.BindFlags = D3D10_BIND_SHADER_RESOURCE;
	gpuCpu2DTexDesc.Usage = D3D10_USAGE_DYNAMIC;
	gpuCpu2DTexDesc.MipLevels = 1;
	gpuCpu2DTexDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	gpuCpu2DTexDesc.MiscFlags = 0;
	gpuCpu2DTexDesc.ArraySize = 1;
	gpuCpu2DTexDesc.SampleDesc.Count = 1;
	gpuCpu2DTexDesc.SampleDesc.Quality = 0;

	cpDevice_->CreateTexture2D( &gpuCpu2DTexDesc, 0, cpGpuCpu2DTex.toCreator() );

	// _[^[QbgeNX`쐬
	D3D10_TEXTURE2D_DESC rtDesc;
	cp< ID3D10Texture2D > cpRenderTargetTex;
	cp< ID3D10RenderTargetView > cpRenderTargetView;

	memset( &rtDesc, 0, sizeof( rtDesc ) );
	rtDesc.Width = 1024;
	rtDesc.Height = 1024;
	rtDesc.MipLevels = 1;
	rtDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
	rtDesc.SampleDesc.Count = 1;
	rtDesc.Usage = D3D10_USAGE_DEFAULT;
	rtDesc.ArraySize = 1;
	rtDesc.BindFlags = D3D10_BIND_RENDER_TARGET | D3D10_BIND_SHADER_RESOURCE;
	rtDesc.CPUAccessFlags = 0;

	cpDevice_->CreateTexture2D( &rtDesc, 0, cpRenderTargetTex.toCreator() );

	// _[^[Qbgr[쐬
	if ( FAILED( cpDevice_->CreateRenderTargetView( cpRenderTargetTex.getPtr(), 0, cpRenderTargetView.toCreator() ) ) ) {
		return -1;
	}

	// eVF[_\[Xr[쐬
	const int texNum = 4;
	cp< ID3D10Texture2D > texes[ texNum ] = {
		cpFileResTex,
		cpGpu2DTex,
		cpGpuCpu2DTex,
		cpRenderTargetTex
	};
	cp< ID3D10ShaderResourceView > cpShaderResViews[ texNum ];
	for ( int i = 0; i < texNum; ++i )
		cpDevice_->CreateShaderResourceView( texes[ i ].getPtr(), 0, cpShaderResViews[ i ].toCreator() );


	// Jp[^
	NumericCounter cameraRotCtr( 0.0f, 0.001f, 0.075f );

	// `p[^
	D3DXMATRIX world, view, proj;
	D3DXMatrixIdentity( &world );
	float fovY = (float)D3DXToRadian( 30.0f );
	D3DXMatrixPerspectiveFovLH( &proj, fovY, (float)w / h, 0.1f, 1000.0f );
	float rtClearColor[ 4 ] = { 0.0f, 0.1f, 0.1f, 1.0f };
	float clearColor[ 4 ] = { 0.3f, 0.4f, 0.5f, 1.0f };
	float cameraDist = 5.0f;
	Number8x8::initialize();
	int counter = 0;
	float th = 0.0f;

	do {
		if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) ) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else {
			// JʒuXV
			cameraRotCtr.setAim( -cameraCurRot_g * 0.01f );
			auto cameraRot = cameraRotCtr.update();
			D3DXMatrixLookAtLH( &view, &D3DXVECTOR3( cameraDist * sinf( cameraRot ), 0.0f, -cameraDist * cosf( cameraRot ) ), &D3DXVECTOR3( 0.0f, 0.0f, 0.0f ), &D3DXVECTOR3( 0.0f, 1.0f, 0.0f ) );

			cpDevice_->RSSetViewports( 1, &vp );

			// fp[^ݒ
			auto worldV = effect->GetVariableByName( "world" );
			worldV->AsMatrix()->SetMatrix( (float*)&world );
			auto viewV = effect->GetVariableByName( "view" );
			viewV->AsMatrix()->SetMatrix( (float*)&view );
			auto projV = effect->GetVariableByName( "proj" );
			projV->AsMatrix()->SetMatrix( (float*)&proj );
			auto texV = effect->GetVariableByName( "tex" );

			const UINT stride = sizeof( V );
			const UINT offset = 0;
			cpDevice_->IASetVertexBuffers( 0, 1, vtxBuffer.getPtrPtr(), &stride, &offset );
			cpDevice_->IASetIndexBuffer( idxBuffer.getPtr(), DXGI_FORMAT_R32_UINT, 0 );
			cpDevice_->IASetInputLayout( vtxLayout.getPtr() );
			cpDevice_->IASetPrimitiveTopology( D3D10_PRIMITIVE_TOPOLOGY_TRIANGLESTRIP );

			// _[^[QbgeNX`̏ꍇAx`
			if ( curTexIdx_g == 3 ) {
				// _[^[QbgɃeNX`0\t|S`
				cpDevice_->OMSetRenderTargets( 1, cpRenderTargetView.getPtrPtr(), dsView.getPtr() );
				cpDevice_->ClearRenderTargetView( cpRenderTargetView.getPtr(), rtClearColor );
				cpDevice_->ClearDepthStencilView( dsView.getPtr(), D3D10_CLEAR_DEPTH, 1.0f, 0 );
				texV->AsShaderResource()->SetResource( cpShaderResViews[ 0 ].getPtr() );

				D3DXMATRIX rotZ, scale;
				th += 0.01f;
				float s = ( 1.0f + cosf( th ) ) + 0.3f;
				D3DXMatrixRotationZ( &rotZ, th );
				D3DXMatrixScaling( &scale, s, s, 1.0f );
				worldV->AsMatrix()->SetMatrix( (float*)&( rotZ * scale ) );
				tech->GetPassByIndex( 0 )->Apply( 0 );
				cpDevice_->DrawIndexed( indicesSize, 0, 0 );
			}

			// CPUANZX\eNX`̏ꍇeNX`̓e
			if ( curTexIdx_g == 2 ) {
				counter++;
				D3D10_MAPPED_TEXTURE2D map;
				if ( SUCCEEDED( cpGpuCpu2DTex->Map( 0, D3D10_MAP_WRITE_DISCARD, 0, &map ) ) ) {
					const uint32_t *p = Number8x8::getNumberBuffer( counter / 10 );
					for ( int i = 0; i < 8; ++i ) {
						memcpy( (char*)map.pData + i * map.RowPitch, p + i * 8, sizeof( uint32_t ) * 8 );
					}
					cpGpuCpu2DTex->Unmap( 0 );
				}
			}

			// obNobt@ɃeNX`\t|S`
			worldV->AsMatrix()->SetMatrix( (float*)&world );
			cpDevice_->OMSetRenderTargets( 1, backBufferRenderTargetView_.getPtrPtr(), dsView.getPtr() );
			cpDevice_->ClearRenderTargetView( backBufferRenderTargetView_.getPtr(), clearColor );
			cpDevice_->ClearDepthStencilView( dsView.getPtr(), D3D10_CLEAR_DEPTH, 1.0f, 0 );
			texV->AsShaderResource()->SetResource( cpShaderResViews[ curTexIdx_g ].getPtr() );
			tech->GetPassByIndex( 0 )->Apply( 0 );
			cpDevice_->DrawIndexed( indicesSize, 0, 0 );

			cpSwapChain_->Present( 1, 0 );

			// [s]L[ꂽobNobt@摜t@CƂĕۑ
			if ( bSaveToFile_g == true ) {
				bSaveToFile_g = false;
				D3DX10SaveTextureToFileA( backBuffer, D3DX10_IFF_BMP, "output.bmp" );

				// 摜f[^ɕۑigpȂR[hƂċLځj
				cp< ID3D10Blob > blob;
				D3DX10SaveTextureToMemory( backBuffer, D3DX10_IFF_BMP, blob.toCreator(), 0 );
				blob->GetBufferPointer();
			}
		}
	} while ( msg.message != WM_QUIT );

	cpDevice_->ClearState();

	return 0;
}